// *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
// ** Copyright UCAR (c) 1992 - 2007
// ** University Corporation for Atmospheric Research (UCAR)
// ** National Center for Atmospheric Research (NCAR)
// ** Research Applications Lab (RAL)
// ** P.O.Box 3000, Boulder, Colorado, 80307-3000, USA
// *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*

////////////////////////////////////////////////////////////////////////

#ifndef  __MET_VSDB_COLUMNS_H__
#define  __MET_VSDB_COLUMNS_H__

////////////////////////////////////////////////////////////////////////

#include "vx_met_util/met_stats.h"

////////////////////////////////////////////////////////////////////////

static const char * hdr_columns [] = {
   "VERSION",     "MODEL",       "FCST_LEAD",
   "FCST_VALID",  "OBTYPE",      "VX_MASK",
   "TYPE",        "VAR",         "LEVEL",
   "="
};

static const char * sl1l2_columns [] = {
   "TOTAL",       "FBAR",        "OBAR",
   "FOBAR",       "FFBAR",       "OOBAR",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * sal1l2_columns [] = {
   "TOTAL",       "FABAR",       "OABAR",
   "FOABAR",      "FFABAR",      "OOABAR",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * vl1l2_columns [] = {
   "TOTAL",       "UFBAR",       "VFBAR",
   "UOBAR",       "VOBAR",       "UVFOBAR",
   "UVFFBAR",     "UVOOBAR",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * val1l2_columns [] = {
   "TOTAL",       "UFABAR",      "VFABAR",
   "UOABAR",      "VOABAR",      "UVFOABAR",
   "UVFFABAR",    "UVOOABAR",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * fho_columns [] = {
   "TOTAL",       "F_RATE",      "H_RATE",
   "O_RATE",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * ctc_columns [] = {
   "TOTAL",       "FY_OY",       "FY_ON",
   "FN_OY",       "FN_ON",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * ctp_columns [] = {
   "TOTAL",       "FY_OY_TP",    "FY_ON_TP",
   "FN_OY_TP",    "FN_ON_TP",    "FY_TP",
   "FN_TP",       "OY_TP",       "ON_TP",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * cfp_columns [] = {
   "TOTAL",       "FY_OY_FP",    "FY_ON_FP",
   "FN_OY_FP",    "FN_ON_FP",    "FY",
   "FN",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * cop_columns [] = {
   "TOTAL",       "FY_OY_OP",    "FY_ON_OP",
   "FN_OY_OP",    "FN_ON_OP",    "OY",
   "ON",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * cts_columns [] = {
   "TOTAL",
   "BASER",       "BASER_NCL",   "BASER_NCU",   "BASER_BCL",   "BASER_BCU",
   "FMEAN",       "FMEAN_NCL",   "FMEAN_NCU",   "FMEAN_BCL",   "FMEAN_BCU",
   "ACC",         "ACC_NCL",     "ACC_NCU",     "ACC_BCL",     "ACC_BCU",
   "FBIAS",       "FBIAS_BCL",   "FBIAS_BCU",
   "PODY",        "PODY_NCL",    "PODY_NCU",    "PODY_BCL",    "PODY_BCU",
   "PODN",        "PODN_NCL",    "PODN_NCU",    "PODN_BCL",    "PODN_BCU",
   "POFD",        "POFD_NCL",    "POFD_NCU",    "POFD_BCL",    "POFD_BCU",
   "FAR",         "FAR_NCL",     "FAR_NCU",     "FAR_BCL",     "FAR_BCU",
   "CSI",         "CSI_NCL",     "CSI_NCU",     "CSI_BCL",     "CSI_BCU",
   "GSS",         "GSS_BCL",     "GSS_BCU",
   "HK",          "HK_NCL",      "HK_NCU",      "HK_BCL",      "HK_BCU",
   "HSS",         "HSS_BCL",     "HSS_BCU",
   "ODDS",        "ODDS_NCL",    "ODDS_NCU",    "ODDS_BCL",    "ODDS_BCU",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * cnt_columns [] = {
   "TOTAL",
   "FBAR",        "FBAR_NCL",    "FBAR_NCU",    "FBAR_BCL",    "FBAR_BCU",
   "FSTDEV",      "FSTDEV_NCL",  "FSTDEV_NCU",  "FSTDEV_BCL",  "FSTDEV_BCU",
   "OBAR",        "OBAR_NCL",    "OBAR_NCU",    "OBAR_BCL",    "OBAR_BCU",
   "OSTDEV",      "OSTDEV_NCL",  "OSTDEV_NCU",  "OSTDEV_BCL",  "OSTDEV_BCU",
   "PR_CORR",     "PR_CORR_NCL", "PR_CORR_NCU", "PR_CORR_BCL", "PR_CORR_BCU",
   "SP_CORR",
   "KT_CORR",
   "RANKS",
   "FRANK_TIES",
   "ORANK_TIES",
   "ME",          "ME_NCL",      "ME_NCU",      "ME_BCL",      "ME_BCU",
   "ESTDEV",      "ESTDEV_NCL",  "ESTDEV_NCU",  "ESTDEV_BCL",  "ESTDEV_BCU",
   "MBIAS",       "MBIAS_BCL",   "MBIAS_BCU",
   "MAE",         "MAE_BCL",     "MAE_BCU",
   "MSE",         "MSE_BCL",     "MSE_BCU",
   "BCMSE",       "BCMSE_BCL",   "BCMSE_BCU",
   "RMSE",        "RMSE_BCL",    "RMSE_BCU",
   "E10",         "E10_BCL",     "E10_BCU",
   "E25",         "E25_BCL",     "E25_BCU",
   "E50",         "E50_BCL",     "E50_BCU",
   "E75",         "E75_BCL",     "E75_BCU",
   "E90",         "E90_BCL",     "E90_BCU",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * mpr_columns [] = {
   "TOTAL",       "INDEX",       "OBS_LAT",
   "OBS_LON",     "OBS_LVL",     "OBS_ELV",
   "FCST",        "OBS",         "CLIMO",
   "INTERP_MTHD", "INTERP_PNTS"
};

static const char * nbrctc_columns [] = {
   "TOTAL",       "FY_OY",       "FY_ON",
   "FN_OY",       "FN_ON",
   "INTERP_PNTS"
};

static const char * nbrcts_columns [] = {
   "TOTAL",
   "BASER",       "BASER_NCL",   "BASER_NCU",   "BASER_BCL",   "BASER_BCU",
   "FMEAN",       "FMEAN_NCL",   "FMEAN_NCU",   "FMEAN_BCL",   "FMEAN_BCU",
   "ACC",         "ACC_NCL",     "ACC_NCU",     "ACC_BCL",     "ACC_BCU",
   "FBIAS",       "FBIAS_BCL",   "FBIAS_BCU",
   "PODY",        "PODY_NCL",    "PODY_NCU",    "PODY_BCL",    "PODY_BCU",
   "PODN",        "PODN_NCL",    "PODN_NCU",    "PODN_BCL",    "PODN_BCU",
   "POFD",        "POFD_NCL",    "POFD_NCU",    "POFD_BCL",    "POFD_BCU",
   "FAR",         "FAR_NCL",     "FAR_NCU",     "FAR_BCL",     "FAR_BCU",
   "CSI",         "CSI_NCL",     "CSI_NCU",     "CSI_BCL",     "CSI_BCU",
   "GSS",         "GSS_BCL",     "GSS_BCU",
   "HK",          "HK_NCL",      "HK_NCU",      "HK_BCL",      "HK_BCU",
   "HSS",         "HSS_BCL",     "HSS_BCU",
   "ODDS",        "ODDS_NCL",    "ODDS_NCU",    "ODDS_BCL",    "ODDS_BCU",
   "INTERP_PNTS"
};

static const char * nbrcnt_columns [] = {
   "TOTAL",
   "FBS",         "FBS_BCL",     "FBS_BCU",
   "FSS",         "FSS_BCL",     "FSS_BCU",
   "INTERP_PNTS"
};

static const char * isc_columns [] = {
   "TOTAL",
   "NSCALE",      "MSE",         "ISC",
   "FENERGY2",    "OENERGY2",    "BASER",
   "FBIAS"
};

static const char * job_sum_columns [] = {
   "TOTAL",
   "MEAN",        "MEAN_NCL",    "MEAN_NCU",     "MEAN_BCL",    "MEAN_BCU",
   "STDEV",       "STDEV_BCL",   "STDEV_BCU",
   "MIN",
   "P10",         "P25",          "P50",         "P75",         "P90",
   "MAX"
};

static const char * job_go_columns [] = {
   "GO_INDEX"
};

////////////////////////////////////////////////////////////////////////

static const int max_vsdb_col     = 73;
static const int vsdb_col_len     = 32;

static const int n_header_columns  = sizeof(hdr_columns)/sizeof(*hdr_columns);
static const int n_sl1l2_columns   = sizeof(sl1l2_columns)/sizeof(*sl1l2_columns);
static const int n_sal1l2_columns  = sizeof(sal1l2_columns)/sizeof(*sal1l2_columns);
static const int n_vl1l2_columns   = sizeof(vl1l2_columns)/sizeof(*vl1l2_columns);
static const int n_val1l2_columns  = sizeof(val1l2_columns)/sizeof(*val1l2_columns);
static const int n_fho_columns     = sizeof(fho_columns)/sizeof(*fho_columns);
static const int n_ctc_columns     = sizeof(ctc_columns)/sizeof(*ctc_columns);
static const int n_ctp_columns     = sizeof(ctp_columns)/sizeof(*ctp_columns);
static const int n_cfp_columns     = sizeof(cfp_columns)/sizeof(*cfp_columns);
static const int n_cop_columns     = sizeof(cop_columns)/sizeof(*cop_columns);
static const int n_cts_columns     = sizeof(cts_columns)/sizeof(*cts_columns);
static const int n_cnt_columns     = sizeof(cnt_columns)/sizeof(*cnt_columns);
static const int n_mpr_columns     = sizeof(mpr_columns)/sizeof(*mpr_columns);
static const int n_nbrctc_columns  = sizeof(nbrctc_columns)/sizeof(*nbrctc_columns);
static const int n_nbrcts_columns  = sizeof(nbrcts_columns)/sizeof(*nbrcts_columns);
static const int n_nbrcnt_columns  = sizeof(nbrcnt_columns)/sizeof(*nbrcnt_columns);
static const int n_isc_columns     = sizeof(isc_columns)/sizeof(*isc_columns);
static const int n_job_sum_columns = sizeof(job_sum_columns)/sizeof(*job_sum_columns);
static const int n_job_go_columns  = sizeof(job_go_columns)/sizeof(*job_go_columns);

////////////////////////////////////////////////////////////////////////

extern int  get_column_offset(const char **, int, const char *);

//
// Format and names for the VSDB columns before the equal sign
//
extern void get_header_format(char *);
extern void get_header_names (char *);

//
// Format and names for the VSDB columns after the equal sign
//
extern void get_column_format(const char **, int, char *);
extern void get_column_names (const char **, int, char *);

//
// Format and names for all of the VSDB columns
//
extern void get_line_format  (const char **, int, char *);
extern void get_line_names   (const char **, int, char *);

////////////////////////////////////////////////////////////////////////

//
// Build the interp_mthd and interp_pnts strings
//
extern void get_mthd_str(char *, int);
extern void get_pnts_str(char *, int);

//
// Build the VSDB line for the columns before the equal sign
//
extern void build_header_str(char *str,
               const char *,   const int,
               const unixtime, const char *,
               const char *,   const char *,
               const char *,   const char *);

//
// Build the VSDB line for the columns after the equal sign
//
extern void build_sl1l2_str (char *, SL1L2Info&);
extern void build_sl1l2_str (char *, CNTInfo&);
extern void build_sal1l2_str(char *, SL1L2Info&);
extern void build_vl1l2_str (char *, VL1L2Info&);
extern void build_val1l2_str(char *, VL1L2Info&);
extern void build_fho_str   (char *, CTSInfo&);
extern void build_ctc_str   (char *, CTSInfo&);
extern void build_ctp_str   (char *, CTSInfo&);
extern void build_cfp_str   (char *, CTSInfo&);
extern void build_cop_str   (char *, CTSInfo&);
extern void build_cts_str   (char *, CTSInfo&, int);
extern void build_cnt_str   (char *, CNTInfo&, int);
extern void build_mpr_str   (char *, PairData*, int);
extern void build_nbrctc_str(char *, NBRCTSInfo&);
extern void build_nbrcts_str(char *, NBRCTSInfo&, int);
extern void build_nbrcnt_str(char *, NBRCNTInfo&, int);
extern void build_isc_str   (char *, ISCInfo&, int);

////////////////////////////////////////////////////////////////////////

#endif   /*  __MET_VSDB_COLUMNS_H__  */

////////////////////////////////////////////////////////////////////////
